<?php

namespace Util;

class KeyGenerator {
	public static function getKeyPair() {
		$config = array(
			"digest_alg" => "sha512",
			"private_key_bits" => 4096,
			"private_key_type" => OPENSSL_KEYTYPE_RSA,
			
			//Change this path to match your system:
			//https://www.php.net/manual/en/openssl.installation.php
			//https://www.php.net/manual/en/function.openssl-csr-new.php
			"config" => 'C:\wamp64\bin\php\php7.2.18\extras\ssl\openssl.cnf',
		);
			
		// Create the private and public key
		$res = openssl_pkey_new($config);

		// Extract the private key from $res to $privateKey
		openssl_pkey_export($res, $privateKey, NULL, $config);

		// Extract the public key from $res to $publicKey
		$publicKey = openssl_pkey_get_details($res);
		
		$obj = new \StdClass();
		$obj->privateKey = $privateKey;
		$obj->publicKey = $publicKey['key'];
		
		return ($obj);
	}
}
